## com.gargoylesoftware.htmlunit.html
Class HtmlTable

    java.lang.Object
      com.gargoylesoftware.htmlunit.html.DomNode
          com.gargoylesoftware.htmlunit.html.DomNamespaceNode
              com.gargoylesoftware.htmlunit.html.DomElement
                  com.gargoylesoftware.htmlunit.html.HtmlElement
                      com.gargoylesoftware.htmlunit.html.StyledElement
                          com.gargoylesoftware.htmlunit.html.ClickableElement
                              com.gargoylesoftware.htmlunit.html.HtmlTable

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, org.w3c.dom.Element, org.w3c.dom.Node

    public class HtmlTable

extends ClickableElement

Wrapper for the HTML element "table".

Version:
  $Revision: 4794 $
Author:
  Mike Bowler, David K. Taylor, Christian Sell, Ahmed Ashour
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement
`HtmlElement.ChildElementsIterator`

Nested classes/interfaces inherited from class com.gargoylesoftware.htmlunit.html.DomNode
`DomNode.ChildIterator, DomNode.DescendantElementsIterator`

Field Summary
`static java.lang.String` `TAG_NAME` The HTML tag represented by this element.

Fields inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement
`TAB_INDEX_OUT_OF_BOUNDS`

Fields inherited from class com.gargoylesoftware.htmlunit.html.DomElement
`ATTRIBUTE_NOT_DEFINED, ATTRIBUTE_VALUE_EMPTY`

Fields inherited from class com.gargoylesoftware.htmlunit.html.DomNode
`AS_TEXT_BLANK, AS_TEXT_BLOCK_SEPARATOR, AS_TEXT_NEW_LINE, AS_TEXT_TAB, PROPERTY_ELEMENT, READY_STATE_COMPLETE, READY_STATE_INTERACTIVE, READY_STATE_LOADED, READY_STATE_LOADING, READY_STATE_UNINITIALIZED`

Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Method Summary
`java.lang.String` `getAlignAttribute()` Returns the value of the attribute "align".
`java.lang.String` `getBgcolorAttribute()` Returns the value of the attribute "bgcolor".
`java.util.List<HtmlTableBody>` `getBodies()` Returns a list of tables bodies defined in this table.
`java.lang.String` `getBorderAttribute()` Returns the value of the attribute "border".
`java.lang.String` `getCaptionText()` Returns the table caption text or an empty string if a caption wasn't specified.
`HtmlTableCell` `getCellAt(int rowIndex, int columnIndex)` Returns the first cell that matches the specified row and column, searching left to right, top to bottom.
`java.lang.String` `getCellPaddingAttribute()` Returns the value of the attribute "cellpadding".
`java.lang.String` `getCellSpacingAttribute()` Returns the value of the attribute "cellspacing".
`HtmlTableFooter` `getFooter()` Returns the table footer or null if a footer wasn't specified.
`java.lang.String` `getFrameAttribute()` Returns the value of the attribute "frame".
`HtmlTableHeader` `getHeader()` Returns the table header or null if a header wasn't specified.
`HtmlTableRow` `getRow(int index)`
`HtmlTableRow` `getRowById(java.lang.String id)` Finds and return the row with the specified id.
`int` `getRowCount()` Computes the number of rows in this table.
`java.util.List<HtmlTableRow>` `getRows()`
`java.lang.String` `getRulesAttribute()` Returns the value of the attribute "rules".
`java.lang.String` `getSummaryAttribute()` Returns the value of the attribute "summary".
`java.lang.String` `getWidthAttribute()` Returns the value of the attribute "width".
`protected boolean` `isBlock()` Indicates if the text representation of this element is made as a block, ie if new lines need to be inserted before and after it.
`protected boolean` `isEmptyXmlTagExpanded()` Indicates if a node without children should be written in expanded form as XML (i.e.

Methods inherited from class com.gargoylesoftware.htmlunit.html.StyledElement
`getClassAttribute, getIdAttribute, getStyleAttribute, getTitleAttribute`

Methods inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement

`addHtmlAttributeChangeListener, appendChildIfNoneExists, blur, checkChildHierarchy, click, click, click, dblClick, dblClick, doClickAction, doType, fireEvent, fireEvent, fireHtmlAttributeAdded, fireHtmlAttributeRemoved, fireHtmlAttributeReplaced, focus, getChildElements, getElementById, getElementsByAttribute, getEnclosingElement, getEnclosingForm, getEnclosingFormOrDie, getEventHandler, getHtmlElementsByTagName, getHtmlElementsByTagNames, getId, getLangAttribute, getNodeName, getOnClickAttribute, getOnDblClickAttribute, getOneHtmlElementByAttribute, getOnKeyDownAttribute, getOnKeyPressAttribute, getOnKeyUpAttribute, getOnMouseDownAttribute, getOnMouseMoveAttribute, getOnMouseOutAttribute, getOnMouseOverAttribute, getOnMouseUpAttribute, getTabIndex, getTextDirectionAttribute, getXmlLangAttribute, hasHtmlElementWithId, isAttributeCaseSensitive, isStateUpdateFirst, isSubmittableByEnter, mouseDown, mouseDown, mouseMove, mouseMove, mouseOut, mouseOut, mouseOver, mouseOver, mouseUp, mouseUp, preventDefault, removeAttribute, removeChild, removeEventHandler, removeHtmlAttributeChangeListener, rightClick, rightClick, setAttributeNS, setEventHandler, setEventHandler, setId, toString, type, type, type, type`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomElement

`cloneNode, getAttribute, getAttributeNode, getAttributeNodeNS, getAttributeNS, getAttributes, getAttributesMap, getElementsByTagName, getElementsByTagNameNS, getNodeType, getSchemaTypeInfo, getTagName, hasAttribute, hasAttributeNS, hasAttributes, namespaces, printOpeningTagContentAsXml, printXml, removeAttributeNode, removeAttributeNS, setAttribute, setAttributeNode, setAttributeNodeNS, setIdAttribute, setIdAttributeNode, setIdAttributeNS`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomNamespaceNode
`getLocalName, getNamespaceURI, getPrefix, getQualifiedName, setPrefix`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomNode

`addDomChangeListener, appendChild, asText, asXml, compareDocumentPosition, fireNodeAdded, fireNodeDeleted, getAllHtmlChildElements, getAncestors, getBaseURI, getByXPath, getCanonicalXPath, getChildNodes, getChildren, getEndColumnNumber, getEndLineNumber, getFeature, getFirstByXPath, getFirstChild, getLastChild, getNextSibling, getNodeValue, getOwnerDocument, getPage, getParentNode, getPreviousSibling, getReadyState, getScriptObject, getStartColumnNumber, getStartLineNumber, getTextContent, getUserData, hasChildNodes, insertBefore, insertBefore, isAncestorOf, isDefaultNamespace, isDisplayed, isEqualNode, isSameNode, isSupported, isTrimmedText, lookupNamespaceURI, lookupPrefix, normalize, notifyIncorrectness, onAddedToPage, onAllChildrenAddedToPage, printChildrenAsXml, remove, removeAllChildren, removeChild, removeDomChangeListener, replace, replaceChild, selectNodes, selectSingleNode, setNextSibling, setNodeValue, setParentNode, setPreviousSibling, setReadyState, setScriptObject, setTextContent, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Node

`appendChild, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

Field Detail

### TAG_NAME

    public static final java.lang.String TAG_NAME

  The HTML tag represented by this element.

  See Also:
    Constant Field Values

Method Detail

### getCellAt

    public final HtmlTableCell getCellAt(int rowIndex,
                                         int columnIndex)

  Returns the first cell that matches the specified row and column, searching left to right, top to bottom.

  Parameters:
    `rowIndex` - the row index
    `columnIndex` - the column index
  Returns:
    the HtmlTableCell at that location or null if there are no cells at that location

### getRows

    public java.util.List<HtmlTableRow> getRows()

  Returns:
    an immutable list containing all the HtmlTableRow objects
  See Also:
    `getRowIterator()`

### getRow

    public HtmlTableRow getRow(int index)
                        throws java.lang.IndexOutOfBoundsException

  Parameters:
    `index` - the 0-based index of the row
  Returns:
    the HtmlTableRow at the given index
  Throws:
    `java.lang.IndexOutOfBoundsException` - if there is no row at the given index
  See Also:
    `getRowIterator()`

### getRowCount

    public final int getRowCount()

  Computes the number of rows in this table. Note that the count is computed dynamically by iterating over all rows.

  Returns:
    the number of rows in this table

### getRowById

    public final HtmlTableRow getRowById(java.lang.String id)
                                  throws ElementNotFoundException

  Finds and return the row with the specified id.

  Parameters:
    `id` - the id of the row
  Returns:
    the row with the specified id
  Throws:
    `ElementNotFoundException` - If the row cannot be found.

### getCaptionText

    public java.lang.String getCaptionText()

  Returns the table caption text or an empty string if a caption wasn't specified.

  Returns:
    the caption text

### getHeader

    public HtmlTableHeader getHeader()

  Returns the table header or null if a header wasn't specified.

  Returns:
    the table header

### getFooter

    public HtmlTableFooter getFooter()

  Returns the table footer or null if a footer wasn't specified.

  Returns:
    the table footer

### getBodies

    public java.util.List<HtmlTableBody> getBodies()

  Returns a list of tables bodies defined in this table. If no bodies were defined then an empty list will be returned.

  Returns:
    a list of `HtmlTableBody` objects

### getSummaryAttribute

    public final java.lang.String getSummaryAttribute()

  Returns the value of the attribute "summary". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "summary" or an empty string if that attribute isn't defined.

### getWidthAttribute

    public final java.lang.String getWidthAttribute()

  Returns the value of the attribute "width". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "width" or an empty string if that attribute isn't defined.

### getBorderAttribute

    public final java.lang.String getBorderAttribute()

  Returns the value of the attribute "border". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "border" or an empty string if that attribute isn't defined.

### getFrameAttribute

    public final java.lang.String getFrameAttribute()

  Returns the value of the attribute "frame". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "frame" or an empty string if that attribute isn't defined.

### getRulesAttribute

    public final java.lang.String getRulesAttribute()

  Returns the value of the attribute "rules". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "rules" or an empty string if that attribute isn't defined.

### getCellSpacingAttribute

    public final java.lang.String getCellSpacingAttribute()

  Returns the value of the attribute "cellspacing". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "cellspacing" or an empty string if that attribute isn't defined.

### getCellPaddingAttribute

    public final java.lang.String getCellPaddingAttribute()

  Returns the value of the attribute "cellpadding". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "cellpadding" or an empty string if that attribute isn't defined.

### getAlignAttribute

    public final java.lang.String getAlignAttribute()

  Returns the value of the attribute "align". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "align" or an empty string if that attribute isn't defined.

### getBgcolorAttribute

    public final java.lang.String getBgcolorAttribute()

  Returns the value of the attribute "bgcolor". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "bgcolor" or an empty string if that attribute isn't defined.

### isBlock

    protected boolean isBlock()

  Indicates if the text representation of this element is made as a block, ie if new lines need to be inserted before and after it.

  Overrides:
    `isBlock` in class `DomNode`
  Returns:
    `true` if this element represents a block

### isEmptyXmlTagExpanded

    protected boolean isEmptyXmlTagExpanded()

  Indicates if a node without children should be written in expanded form as XML (i.e. with closing tag rather than with "/>")

  Overrides:
    `isEmptyXmlTagExpanded` in class `DomElement`
  Returns:
    `true` as browsers ignore self closing `table` tags.

Copyright © 2002-2011 Gargoyle Software Inc.. All Rights Reserved.